#include <stdio.h>
#include "fa.h"

#define FA_SZ 128

unsigned char reached[FA_SZ];
unsigned char fa[FA_SZ][7];

void error(char *s) {
    fprintf(stderr, "error: %s\n", s);
    exit(1);
}

int search(int a, int b) {
    int i;
    int found = 0;

    if(reached[a])
	return 0;
    reached[a]=1;

    for(i = 0; i < 7; i++)
	if(fa[a][i] == b) {
	    found=1;
	    printf("%d(%d) ", a, i);
	    return 1;
	    break;
	}
    if(!found)
	for(i = 0; i < 7; i++)
	    if(!reached[fa[a][i]])
		if(search(fa[a][i], b)) {
		    printf("%d(%d) ", a, i);
		    return 1;
		}
    return 0;
}

void pr(char *s, int code) {
    int i;
    printf("transtab[%s] = \"",s);
    for(i = 0; i < FA_SZ; i++) {
	printf("\\%03d", fa[i][code]);
    }
    printf("\"\n");
}

void wr(int code) {
    int i;
    for(i = 0; i < FA_SZ; i++) {
	write(1, &fa[i][code], 1);
    }
}
	
int main(int argc, char *argv[]) {
    int i, j;
    int u;

    for(i = 0; i < FA_SZ; i++)
	for(j = 0; j < 7; j++)
	    switch(j) {
	      case 0:  /* U */
		u = GET_U(i);
		if(u < 3)
		    u++;
		fa[i][j] = (i & ~U) | u;
		break;	
	      case 5: /* B */
		fa[i][j] = i | B;
		break;
	      case 1: /* EM */
		fa[i][j] = (i&S) ? i : i ^ EM;
		break;
	      case 4: /* I */
		fa[i][j] = i | I;
		break;
	      case 2: /* S */
		fa[i][j] = (i&~EM) | S;
		break;
	      case 3: /* TT */
		fa[i][j] = i|TT;
		break;
	      case 6: /* PL */
		fa[i][j] = 0;
		break;
	      default:
		error("bad transition code");
	    }
    
    if(0)
    for(i = 0; i < FA_SZ; i++) {
	printf("transtab[%d] = \"", i);
	for(j = 0; j < 7; j++)
	    printf("\\%03d", fa[i][j]);
	printf("\"\n");
    }

    if(0) {
    printf("#define Ub 0\n");
    printf("#define Bb 1\n");
    printf("#define EMb 2\n");
    printf("#define Ib 3\n");
    printf("#define Sb 4\n");
    printf("#define TTb 5\n");
    printf("#define PLb 6\n");

    pr("Ub",Ub);
    pr("Bb",Bb);
    pr("EMb",EMb);
    pr("Ib",Ib);
    pr("Sb",Sb);
    pr("TTb",TTb);
    pr("PLb",PLb);
    }

    wr(Ub);
    wr(EMb);
    wr(Sb);
    wr(TTb);
    wr(Ib);
    wr(Bb);
    wr(PLb);
    
    if(0) {
    for(i = 0; i < FA_SZ; i++) {
	for(j = 0; j < FA_SZ; j++)
	    reached[j]=0;
	printf("%d: ", i);
	search(i, I);
	putchar('\n');
    }
    }
    return 0;
}


