#include <stdio.h>
#include "infer.h"

#define FA_SZ 128

unsigned char fa[FA_SZ][7];

void error(char *s) {
    fprintf(stderr, "error: %s\n", s);
    exit(1);
}

typedef unsigned char uchar;

typedef struct {
    int font;
    uchar szcol;
} tagging;

void tcollapse(tagging *t1, tagging *t2, tagging *res) {
    int col1 = CL(t1->szcol);
    int sz1 = SZ(t1->szcol);
    int col2 = CL(t2->szcol);
    int sz2 = SZ(t2->szcol);
    int szcol = MK_SZCOL(sz1 == -1 ? sz2 : sz1,col1 == -1 ? col2 : col1);
    int u, b, i, s, tt, pl, r, em;
   
    if(t2->font & PL) {
	*res = *t2;
	res->szcol = szcol;
	return;
    }
    u = t1->font & U + t2->font & U;
    if(u>3) u=3;
    b = (t1->font & B) | (t2->font & B);
    i = (t1->font & I) | (t2->font & I);
    tt = (t1->font & TT) | (t2->font & TT);
    s = (t1->font & S) | (t2->font & S);
    em = (!s && ((t1->font & EM) | (t2->font & EM))) << 3;
    r = u | b | i | tt | s | em;
    pl = (!((r & ~EM) == (U|B|I|TT|S)) && (t1->font & PL)) << 7;
    r |= pl;
    res->szcol = szcol;
    res->font = r;
}
    
void mktab() {
    tagging t1, t2, res;
    int i, j;
 
    for(i = 0; i < 256; i++) {
	printf("tcollapse[%d] = \"",i);
	for(j = 0; j < 256; j++) {
	    t1.font = i; 
	    t2.font = j;
	    tcollapse(&t1,&t2,&res);
	    printf("\\%3d", res.font);
	}
	printf("\"\n");
    }
}

	    
	
int main(int argc, char *argv[]) {
    mktab();
}


