(* -*- sml -*-
 * opt-util.cpp
 *
 * (C) 2001 Lucent Technologies, Bell Labs
 *)
structure OptUtil : sig
    val nopTagging : Document.tagging

    val isNop : Document.tagging -> bool

    val collapseFontTagging : word * word -> word

    val collapseTagging : Document.tagging * Document.tagging
			  -> Document.tagging
end = struct

    structure D = Document
    structure U = Unsafe

#include "bits.ins"
#include "sub.ins"

    val nopTagging = { color = ~1, sz = ~1, font = 0w0 }

    fun isNop { color = ~1, sz = ~1, font = 0w0 } = true
      | isNop _ = false

    fun collapseFontTagging (f1, f2) =
	  stringSubW(arraySubW(Tables.tcollapseTbl, f1), f2)

    fun collapseTagging (t1 : D.tagging, t2: D.tagging) = {
	    font = collapseFontTagging (#font t1, #font t2),
	    color = if (#color t2 = ~1) then #color t1 else #color t2,
	    sz = if (#sz t2 = ~1) then #sz t1 else #sz t2
	  }
end
